# coding: utf-8

"""
    Root.io API

    This is the API documentation for Root.io.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Account(BaseModel):
    """
    Account
    """ # noqa: E501
    created_at: Optional[StrictStr] = None
    email: StrictStr
    external_id: StrictStr
    id: Optional[StrictStr] = None
    last_login_at: Optional[StrictStr] = None
    name: StrictStr
    org_role_bindings: Optional[List[OrgRoleBinding]] = None
    provider: Optional[StrictStr] = None
    updated_at: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["created_at", "email", "external_id", "id", "last_login_at", "name", "org_role_bindings", "provider", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Account from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in org_role_bindings (list)
        _items = []
        if self.org_role_bindings:
            for _item in self.org_role_bindings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['org_role_bindings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Account from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "email": obj.get("email"),
            "external_id": obj.get("external_id"),
            "id": obj.get("id"),
            "last_login_at": obj.get("last_login_at"),
            "name": obj.get("name"),
            "org_role_bindings": [OrgRoleBinding.from_dict(_item) for _item in obj["org_role_bindings"]] if obj.get("org_role_bindings") is not None else None,
            "provider": obj.get("provider"),
            "updated_at": obj.get("updated_at")
        })
        return _obj

from root_io.sdk.cloud_client.models.org_role_binding import OrgRoleBinding
# TODO: Rewrite to not use raise_errors
Account.model_rebuild(raise_errors=False)

